package bc_session;

use bc_handleproto;
use bc_packetgen;

use strict;

sub run {
  my ($rin, $rout, $connectInterval, $lastConnectAttempt, $positionResendTime, $curTime, $first, $packetResendTime, $lastPacketResent, $lastPositionResent);

  $rin = '';
  vec($rin, fileno($bc_global::socketfd), 1) = 1;

  # State: connecting
  $bc_global::state = 0;

  $connectInterval = 10000;
  $lastConnectAttempt = 0;

  $packetResendTime = 750;
  $lastPacketResent = bc_handleproto::getTicks();

  $positionResendTime = 1000;
  $lastPositionResent = bc_handleproto::getTicks();

  while ($bc_global::state != 2) { # Disconnected
    $curTime = bc_handleproto::getTicks();

    if ($bc_global::state == 0) { # Connecting
      if (select($rout = $rin, undef, undef, 0)) {
	bc_handleproto::S2C_recv();
      }
      if ($curTime - $lastConnectAttempt > $connectInterval) {
	if ($first == 1) { bc_packetgen::send_disconnect(); }
	# Key exchange
	#bc_packetgen::send_enc_request_noenc();
	bc_packetgen::send_enc_request();

	$lastConnectAttempt = $curTime;
	$first = 1;
      }
    }

    if ($bc_global::state == 1) { # Running
      if (select($rout = $rin, undef, undef, 0)) {
	bc_handleproto::S2C_recv();
      }
      if ($curTime - $lastPacketResent > $packetResendTime) {
	bc_packetgen::resend_unacked_msgs();
	$lastPacketResent = $curTime;
      }
      if ($curTime - $lastPositionResent > $positionResendTime) {
	bc_packetgen::send_position();
	$lastPositionResent = $curTime;

	# 1 sec
	bc_modules::exec_interpreters("second");
      }
    }

    select(undef, undef, undef, 0.25);
  }
  bc_packetgen::send_leave_arena();
}

#sub receieve {
#  while ($bc_global::state != 2) {
#    bc_handleproto::S2C_recv();
#  }
#}

# Signal EOF
1;
